%global dlrn_nvr python-tripleoclient-12.3.2.dev91-0.20200615103425.6f877f6
%global dlrn 1
%define upstream_version 12.3.2.dev91
%{lua: posix.setenv("RHEL_ALLOW_PYTHON2_FOR_BUILD",1)}
# Macros for py2/py3 compatibility
%if 0%{?fedora} || 0%{?rhel} > 7
%global pyver 3
%else
%global pyver 2
%endif

%global pyver_bin python%{pyver}
%global pyver_sitelib %{expand:%{python%{pyver}_sitelib}}
%global pyver_install %{expand:%{py%{pyver}_install}}
%global pyver_build %{expand:%{py%{pyver}_build}}
# End of macros for py2/py3 compatibility

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

%global client tripleoclient

%global common_desc \
python-tripleoclient is a Python plugin to OpenstackClient \
for TripleO <https://github.com/openstack/python-tripleoclient>.

Name:           python-tripleoclient
Version: 12.3.2
Release: 0.20200615103427.6f877f6%{?dist}
Summary:        OpenstackClient plugin for tripleoclient

License:        ASL 2.0
URL:            https://pypi.python.org/pypi/python-tripleoclient
Source0: python-tripleoclient-12.3.2.dev91-0.20200615103425.6f877f6.tar.gz

#
# patches_ignore=DROP-IN-RPM
# patches_base=6f877f6bbf53ca18b4dfc0878c75483ea1f900d6
Patch0001: 0001-DOWNSTREAM-ONLY-Adding-check-if-Sahara-is-enabled.patch
Patch0002: 0002-DOWNSTREAM-ONLY-Make-container-images-file-required.patch
Patch0003: 0003-Refactor-upgrade-prepare-and-converge.patch
Patch0004: 0004-TRAIN-ONLY-Do-not-encode-hostnames-in-validation-res.patch

BuildArch:      noarch

BuildRequires:  git
BuildRequires:  openstack-macros

%description
%{common_desc}

%package -n python%{pyver}-%{client}
Summary: OpenstackClient plugin for tripleoclient
%{?python_provide:%python_provide python%{pyver}-%{client}}

BuildRequires:  python%{pyver}-devel
BuildRequires:  python%{pyver}-pbr
BuildRequires:  python%{pyver}-setuptools
# testing requirements
BuildRequires:  python%{pyver}-stestr
BuildRequires:  python%{pyver}-fixtures
BuildRequires:  python%{pyver}-mock
BuildRequires:  python%{pyver}-testrepository
BuildRequires:  python%{pyver}-testtools
BuildRequires:  python%{pyver}-cliff
BuildRequires:  python%{pyver}-ironicclient
BuildRequires:  python%{pyver}-ironic-inspector-client
BuildRequires:  python%{pyver}-heatclient
BuildRequires:  python%{pyver}-mistralclient
BuildRequires:  python%{pyver}-openstackclient
BuildRequires:  python%{pyver}-oslo-config
BuildRequires:  python%{pyver}-testscenarios
BuildRequires:  python%{pyver}-passlib
BuildRequires:  python%{pyver}-osc-lib-tests
BuildRequires:  openstack-tripleo-common
BuildRequires:  redhat-lsb-core
BuildRequires:  openstack-macros
%if %{pyver} == 2
BuildRequires:  PyYAML
BuildRequires:  python-psutil
BuildRequires:  python-requests-mock
BuildRequires:  python-websocket-client
%else
BuildRequires:  python%{pyver}-PyYAML
BuildRequires:  python%{pyver}-psutil
BuildRequires:  python%{pyver}-requests-mock
BuildRequires:  python%{pyver}-websocket-client
%endif

Requires:       jq
Requires:       ncurses
Requires:       openstack-selinux
Requires:       python%{pyver}-babel >= 2.3.4
Requires:       python%{pyver}-cliff
Requires:       python%{pyver}-cryptography >= 2.1
Requires:       python%{pyver}-heatclient >= 1.10.0
Requires:       python%{pyver}-ironic-inspector-client >= 1.5.0
Requires:       python%{pyver}-ironicclient >= 2.3.0
Requires:       python%{pyver}-mistralclient >= 3.1.0
Requires:       python%{pyver}-openstackclient >= 3.12.0
Requires:       python%{pyver}-osc-lib >= 1.8.0
Requires:       python%{pyver}-passlib
Requires:       python%{pyver}-pbr
Requires:       python%{pyver}-six
Requires:       python%{pyver}-zaqarclient >= 1.0.0

%if %{pyver} == 2
Requires:       python-ipaddress
Requires:       python-psutil
Requires:       python-simplejson >= 3.5.1
Requires:       python-websocket-client
Requires:       python2-futures
%else
Requires:       python%{pyver}-psutil
Requires:       python%{pyver}-simplejson >= 3.5.1
Requires:       python%{pyver}-websocket-client
%endif

Requires:       sos
Requires:       openstack-tripleo-common >= 11.3.1
Requires:       python%{pyver}-tripleo-common >= 11.3.1
Requires:       os-net-config
Requires:       rsync

# Dependencies for a containerized undercloud
Requires:       python%{pyver}-tripleoclient-heat-installer
# Dependency for correct validations
Requires:       openstack-tripleo-validations
# Dependency for image building
Requires:       openstack-ironic-python-agent-builder
Requires:       openstack-tripleo-image-elements
Requires:       openstack-tripleo-puppet-elements
Requires:       xfsprogs

Obsoletes: python-rdomanager-oscplugin < 0.0.11
Provides: python-rdomanager-oscplugin = %{version}-%{release}

%description -n python%{pyver}-%{client}
%{common_desc}

%package -n python%{pyver}-%{client}-heat-installer
Summary:        Components required for a containerized undercloud
%{?python_provide:%python_provide python%{pyver}-%{client}-heat-installer}

# Required for containerized undercloud
Requires:       buildah
Requires:       podman
Requires:       openvswitch
Requires:       openstack-heat-agents >= 1.6.0
Requires:       openstack-heat-api >= 11.0.0
Requires:       openstack-heat-engine >= 11.0.0
Requires:       python%{pyver}-paunch >= 4.2.0
# required as we now use --heat-native
Requires:       openstack-heat-monolith >= 11.0.0
Requires:       openstack-tripleo-heat-templates >= 9.0.0
Requires:       puppet-tripleo >= 9.3.0

%description -n python%{pyver}-%{client}-heat-installer
python-tripleoclient-heat-installer is a sub-package that contains all dependencies to
deploy a containerized undercloud with tripleo client.

%prep
%autosetup -n %{name}-%{upstream_version} -S git
sed -i '/setup_requires/d; /install_requires/d; /dependency_links/d' setup.py

# Remove the requirements file so that pbr hooks don't add it
# to distutils requires_dist config
%py_req_cleanup

%build
%{pyver_build}
PYTHONPATH=. oslo-config-generator-%{pyver} --config-file=config-generator/undercloud.conf
PYTHONPATH=. oslo-config-generator-%{pyver} --config-file=config-generator/minion.conf

%install
%{pyver_install}
# undercloud.conf.sample needs to be copied by the user when deploying an undercloud,
# so 644 is enough to make it happen. Note instack-undercloud had similar permissions for
# this file.
install -p -D -m 644 undercloud.conf.sample  %{buildroot}/%{_datadir}/%{name}/undercloud.conf.sample
install -p -D -m 644 minion.conf.sample  %{buildroot}/%{_datadir}/%{name}/minion.conf.sample
mkdir -p %{buildroot}/%{_sharedstatedir}/tripleo-heat-installer

%check
# (amoralej) ignore unit tests - 
# it misses https://github.com/openstack/python-tripleoclient/commit/e7132d47ea9b90c70fa2414d79c86c9a1dfc73a3
PYTHON=%{pyver_bin} stestr-%{pyver} run ||:

%files -n python%{pyver}-%{client}
%{_datadir}/%{name}
%{pyver_sitelib}/tripleoclient*
%{pyver_sitelib}/python_tripleoclient*
%doc LICENSE README.rst
%dir %{_sharedstatedir}/tripleo-heat-installer

%files -n python%{pyver}-%{client}-heat-installer

%changelog
* Wed Jun 24 2020 Cédric Jeanneret <cjeanner@redhat.com> 12.3.2-0.20200615103427.6f877f6
- [TRAIN ONLY] Do not encode hostnames in validation result (rhbz#1850347)

* Tue Jun 23 2020 Lon Hohberger <lhh@redhat.com> 12.3.2-0.20200615103426.6f877f6
- Refactor upgrade prepare and converge. (rhbz#1846591)

* Mon Jun 15 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- TripleO Validations Logging CLI Introduction

* Fri Jun 05 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- [TRAIN-AND-OLDER] Improve timeout error handling

* Fri May 29 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Remove left over print
- Fix upgrade prompt

* Fri May 22 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Removed job tripleo-ci-centos-7-scenario009-multinode-oooq-container

* Thu May 21 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Use undercloud upgrade to update all required pkgs

* Thu May 21 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- [stable/train] Revert "Remove download_ansible_playbooks"

* Mon May 18 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches

* Fri May 15 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Expose --limit, --skip-tags, and --tags on the CLI.

* Thu May 14 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Add option to skip ipa cleanup when deleting overclouds

* Tue May 12 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Expose --limit, --skip-tags, and --tags on the CLI. (rhbz#1767581)
- tripleo-ci-centos-7-containerized-undercloud-upgrades -> NV

* Thu Apr 30 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Raise a new ValueError with the contents of the JSON is parsing fails

* Wed Apr 29 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- [stable-only] Add retry for inserting temp_ssh_key

* Wed Apr 29 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- [stable only] Remove timeout in config-download-export

* Wed Apr 29 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Add login flag to container image prepare defaults

* Tue Apr 28 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- [stable-only] Raise error for temp_ssh_key import failure

* Thu Apr 23 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Add release note for undercloud.conf parsing

* Thu Apr 23 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches

* Tue Apr 21 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Update necessary packages before undercloud upgarde.
- Fix misused deployment vs connection timeouts

* Mon Apr 13 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- [DOWNSTREAM-ONLY] Make container images file required (rhbz#1819016)
- Fix ResourceWarning: unclosed file
- Ensure the undercloud output dir constant is consistent
- Add logic to clean up ipa on stack delete

* Sat Apr 04 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Improve container_images_file comments

* Tue Mar 31 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Normalize the 'undercloud-passwords.conf' return data
- baremetal provision expose concurrency and timeout

* Tue Mar 24 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Add --work-dir option to container image build command

* Tue Mar 17 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Local file based image uploader

* Mon Mar 16 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Refactor image upload command

* Fri Mar 13 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Add option to control ironic network interfaces

* Fri Mar 13 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Use correct default key file and normalize the usage

* Wed Mar 11 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- overcloud: set DeployIdentifier to '' if --skip-deploy-identifier is used

* Wed Mar 11 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Update undercloud.conf with correct SSL information
- Make _get_undercloud_host_entry(self) python3 friendly

* Wed Mar 11 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Relax ~/.config permissions

* Sat Feb 29 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Remove extra whitespaces from getent.
- Fix default image registry address lookup

* Fri Feb 28 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Increase ssh port timeout

* Fri Feb 28 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Add source auth to image push

* Wed Feb 26 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Allow import to specify image location ipxe=false

* Fri Feb 21 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- undercloud: introduce undercloud_enable_paunch option

* Tue Feb 18 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Revert "Default to zero verbosity when using Ansible."
- Revert "Added for support for generating overcloud clouds.yaml"
- Implement utils.copy_clouds_yaml
- tripleo_deploy: set RootStackName

* Fri Feb 14 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Enable stack status output for tripleo deploy

* Mon Feb 10 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Fix all py27 tests

* Fri Feb 07 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- openstack overcloud node delete --baremetal-deployment

* Mon Feb 03 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Revert "Remove panko"

* Thu Jan 30 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Revert "Remove panko" (rhbz#1795759)

* Thu Jan 30 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Merge "Enforce 0600 permissions on private SSH key file." into stable/train
- Merge "Default to zero verbosity when using Ansible." into stable/train
- Default to zero verbosity when using Ansible.
- Enforce 0600 permissions on private SSH key file.

* Wed Jan 29 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Merge "Complete overcloud deploy --baremetal-deployment" into stable/train
- Merge "Improvements to unprovision command" into stable/train
- Complete overcloud deploy --baremetal-deployment
- Improvements to unprovision command

* Thu Jan 09 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Merge "Handle config-download in progress in tripleoclient" into stable/train
- Handle config-download in progress in tripleoclient

* Wed Jan 08 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Add additional ssh timeout options

* Tue Jan 07 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.1-1
- Update patches
- Merge "TripleO Validator CLI Refactor" into stable/train
- TripleO Validator CLI Refactor

* Fri Jan 03 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.0-1
- Update patches
- Allow ctlplane subnets in undercloud chrony acl rules

* Fri Jan 03 2020 OSP Prod Chain <dev-null@redhat.com> 12.3.0-1
- Update patches
- Catch exceptions when processing subnets

* Mon Dec 30 2019 OSP Prod Chain <dev-null@redhat.com> 12.3.0-1
- Update patches
- Pass container name to update_nodes workflow

* Mon Dec 16 2019 OSP Prod Chain <dev-null@redhat.com> 12.3.0-1
- Update patches
- Merge "Make containerized-undercloud-upgrades vote on train" into stable/train
- Make containerized-undercloud-upgrades vote on train

* Sat Dec 14 2019 OSP Prod Chain <dev-null@redhat.com> 12.3.0-1
- [DOWNSTREAM-ONLY] Adding check if Sahara is enabled (rhbz#1730322)
- Retry the connection to heat-api when 500 code

* Mon Dec 09 2019 OSP Prod Chain <dev-null@redhat.com> 12.3.0-1
- Update patches
- Honor --heat-user argument in heat launcher

* Sat Dec 07 2019 OSP Prod Chain <dev-null@redhat.com> 12.3.0-1
- Update patches
- Add locks to container image commands

* Thu Dec 05 2019 OSP Prod Chain <dev-null@redhat.com> 12.3.0-1
- Update patches
- Use configured passwords
- Include memcached_node_ips in the output for the undercloud

* Mon Dec 02 2019 OSP Prod Chain <dev-null@redhat.com> 12.3.0-1
- Update patches
- Fix inspector ip range for dhcpv6-stateless

* Tue Nov 26 2019 OSP Prod Chain <dev-null@redhat.com> 12.3.0-1
- Update patches
- Switch to use process executor

* Fri Nov 15 2019 OSP Prod Chain <dev-null@redhat.com> 12.3.0-1
- Update patches
- Fix overcloud cell export after refactoring

* Thu Nov 14 2019 OSP Prod Chain <dev-null@redhat.com> 12.3.0-1
- Update patches
- Add openstack overcloud export

* Wed Nov 13 2019 OSP Prod Chain <dev-null@redhat.com> 12.3.0-1
- Update patches
- Drop Mistral support for the Validations CLI
- Get rid of Mistral for running Validations by Groups
- Get rid of Mistral for listing validations

* Sat Nov 09 2019 OSP Prod Chain <dev-null@redhat.com> 12.3.0-1
- Update patches
- Support undercloud fake-hardware ironic driver

* Tue Oct 22 2019 OSP Prod Chain <dev-null@redhat.com> 12.3.0-1
- Update patches

* Fri Oct 18 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Merge "Undercloud hosts entries in overcloud parameters" into stable/train
- Merge "Use name for container registry" into stable/train
- Undercloud hosts entries in overcloud parameters
- Use name for container registry

* Thu Oct 17 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Update TOX/UPPER_CONSTRAINTS_FILE for stable/train
- Prepare stable/train

* Mon Oct 14 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Merge "Ensure that --output-env-file handles path expansion"
- Add option to control IPv6 address mode
- Ensure that --output-env-file handles path expansion

* Thu Oct 10 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Merge "Don't set transport=local in ansible.cfg"
- Merge "Handle a deployment that was manually cancelled."
- Handle a deployment that was manually cancelled.
- Don't set transport=local in ansible.cfg

* Tue Oct 08 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Merge "Set option:mtu in inspector dnsmasq"
- Merge "Don't use --registry-url for image show auth"
- Merge "Removed references to bm-deploy images"
- Merge "Fix message of unused_params and invalid_role_specific_params."
- Merge "IronicIpVersion: 12.3.2
- Removed references to bm-deploy images
- Fix message of unused_params and invalid_role_specific_params.
- IronicIpVersion: 12.3.2
- Set option:mtu in inspector dnsmasq
- Don't use --registry-url for image show auth

* Tue Oct 01 2019 OSP Prod Chain <dev-null@redhat.com> XXX-XXX
- Update patches
- Merge "Close some file descriptors that were left open"
- Close some file descriptors that were left open

